Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ClientCommunicator.cs	(revision 3578)
@@ -90,7 +90,7 @@
     /// <param name="e"></param>
     void lifecycleManager_OnServerHeartbeat(object sender, EventArgs e) {
-      HiveLogger.Info(this.ToString() + ": Server Heartbeat ticked");
-
-      using (TransactionScope scope = new TransactionScope()) {
+      Logger.Debug("Server Heartbeat ticked");
+
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
 
         List<ClientDto> allClients = new List<ClientDto>(DaoLocator.ClientDao.FindAll());
@@ -101,14 +101,13 @@
 
             if (!lastHeartbeats.ContainsKey(client.Id)) {
-              HiveLogger.Info(this.ToString() + ": Client " + client.Id +
+              Logger.Info("Client " + client.Id +
                               " wasn't offline but hasn't sent heartbeats - setting offline");
               client.State = State.offline;
               DaoLocator.ClientDao.Update(client);
-              HiveLogger.Info(this.ToString() + ": Client " + client.Id +
+              Logger.Info("Client " + client.Id +
                               " wasn't offline but hasn't sent heartbeats - Resetting all his jobs");
               foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
                 //maybe implementa n additional Watchdog? Till then, just set them offline..
-                DaoLocator.JobDao.SetJobOffline(job);                
-                //jobManager.ResetJobsDependingOnResults(job);
+                DaoLocator.JobDao.SetJobOffline(job);                                
               }
             } else {
@@ -119,5 +118,5 @@
               if (dif.TotalSeconds > ApplicationConstants.HEARTBEAT_MAX_DIF) {
                 // if client calculated jobs, the job must be reset
-                HiveLogger.Info(this.ToString() + ": Client timed out and is on RESET");
+                Logger.Info("Client timed out and is on RESET");
                 foreach (JobDto job in DaoLocator.JobDao.FindActiveJobsOfClient(client)) {
                   jobManager.ResetJobsDependingOnResults(job);
@@ -127,5 +126,5 @@
                   }
                 }
-
+                Logger.Debug("setting client offline");
                 // client must be set offline
                 client.State = State.offline;
@@ -134,4 +133,5 @@
                 DaoLocator.ClientDao.Update(client);
 
+                Logger.Debug("removing it from the heartbeats list");
                 heartbeatLock.EnterWriteLock();
                 lastHeartbeats.Remove(client.Id);
@@ -264,17 +264,12 @@
     /// <returns></returns>
     public ResponseHB ProcessHeartBeat(HeartBeatData hbData) {
-      HiveLogger.Debug(this.ToString() + ": BEGIN Processing Heartbeat for Client " + hbData.ClientId);
-      HiveLogger.Debug(this.ToString() + ": BEGIN Fetching Adapters");
-      HiveLogger.Debug(this.ToString() + ": END Fetched Adapters");
-      HiveLogger.Debug(this.ToString() + ": BEGIN Starting Transaction");
-
-      HiveLogger.Debug(this.ToString() + ": END Started Transaction");
+      Logger.Debug("BEGIN Processing Heartbeat for Client " + hbData.ClientId);
 
       ResponseHB response = new ResponseHB();
       response.ActionRequest = new List<MessageContainer>();
 
-      HiveLogger.Debug(this.ToString() + ": BEGIN Started Client Fetching");
+      Logger.Debug("BEGIN Started Client Fetching");
       ClientDto client = DaoLocator.ClientDao.FindById(hbData.ClientId);
-      HiveLogger.Debug(this.ToString() + ": END Finished Client Fetching");
+      Logger.Debug("END Finished Client Fetching");
       // check if the client is logged in
       if (client.State == State.offline || client.State == State.nullState) {
@@ -283,5 +278,5 @@
         response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.NoMessage));
 
-        HiveLogger.Error(this.ToString() + " ProcessHeartBeat: Client state null or offline: " + client);
+        Logger.Error("ProcessHeartBeat: Client state null or offline: " + client);
 
         return response;
@@ -292,7 +287,7 @@
 
       // save timestamp of this heartbeat
-      HiveLogger.Debug(this.ToString() + ": BEGIN Locking for Heartbeats");
+      Logger.Debug("BEGIN Locking for Heartbeats");
       heartbeatLock.EnterWriteLock();
-      HiveLogger.Debug(this.ToString() + ": END Locked for Heartbeats");
+      Logger.Debug("END Locked for Heartbeats");
       if (lastHeartbeats.ContainsKey(hbData.ClientId)) {
         lastHeartbeats[hbData.ClientId] = DateTime.Now;
@@ -302,7 +297,7 @@
       heartbeatLock.ExitWriteLock();
 
-      HiveLogger.Debug(this.ToString() + ": BEGIN Processing Heartbeat Jobs");
+      Logger.Debug("BEGIN Processing Heartbeat Jobs");
       processJobProcess(hbData, response);
-      HiveLogger.Debug(this.ToString() + ": END Processed Heartbeat Jobs");
+      Logger.Debug("END Processed Heartbeat Jobs");
 
       //check if new Cal must be loaded
@@ -314,10 +309,10 @@
         //client.CalendarSyncStatus = CalendarState.Fetching;
         
-        HiveLogger.Info(this.ToString() + " fetch or forcefetch sent");        
+        Logger.Info("fetch or forcefetch sent");        
       }
 
       // check if client has a free core for a new job
       // if true, ask scheduler for a new job for this client
-      HiveLogger.Debug(this.ToString() + ": BEGIN Looking for Client Jobs");
+      Logger.Debug(" BEGIN Looking for Client Jobs");
       if (hbData.FreeCores > 0 && scheduler.ExistsJobForClient(hbData)) {
         response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.FetchJob));
@@ -325,5 +320,5 @@
         response.ActionRequest.Add(new MessageContainer(MessageContainer.MessageType.NoMessage));
       }
-      HiveLogger.Debug(this.ToString() + ": END Looked for Client Jobs");
+      Logger.Debug(" END Looked for Client Jobs");
       response.Success = true;
       response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_HEARTBEAT_RECEIVED;
@@ -332,5 +327,5 @@
 
       //tx.Commit();
-      HiveLogger.Debug(this.ToString() + ": END Processed Heartbeat for Client " + hbData.ClientId);
+      Logger.Debug(" END Processed Heartbeat for Client " + hbData.ClientId);
       return response;
     }
@@ -344,5 +339,5 @@
     /// <param name="response"></param>
     private void processJobProcess(HeartBeatData hbData, ResponseHB response) {
-      HiveLogger.Info(this.ToString() + " processJobProcess: Started for Client " + hbData.ClientId);
+      Logger.Debug("Started for Client " + hbData.ClientId);
       List<JobDto> jobsOfClient = new List<JobDto>(DaoLocator.JobDao.FindActiveJobsOfClient(DaoLocator.ClientDao.FindById(hbData.ClientId)));
       if (hbData.JobProgress != null && hbData.JobProgress.Count > 0) {        
@@ -350,5 +345,5 @@
           response.Success = false;
           response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_IS_NOT_BEEING_CALCULATED;
-          HiveLogger.Error(this.ToString() + " processJobProcess: There is no job calculated by this user " + hbData.ClientId);
+          Logger.Error("There is no job calculated by this user " + hbData.ClientId);
           return;
         }
@@ -360,5 +355,5 @@
             response.Success = false;
             response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_IS_NOT_BEEING_CALCULATED;
-            HiveLogger.Error(this.ToString() + " processJobProcess: There is no job calculated by this user " + hbData.ClientId + " Job: " + curJob);
+            Logger.Error("There is no job calculated by this user " + hbData.ClientId + " Job: " + curJob);
           } else if (curJob.State == State.abort) {
             // a request to abort the job has been set
@@ -392,7 +387,7 @@
             if (newAssignedJobs.ContainsKey(currJob.Id)) {
               newAssignedJobs[currJob.Id]--;
-              HiveLogger.Error(this.ToString() + " processJobProcess: Job TTL Reduced by one for job: " + currJob + "and is now: " + newAssignedJobs[currJob.Id] + ". User that sucks: " + currJob.Client);
+              Logger.Error("Job TTL Reduced by one for job: " + currJob + "and is now: " + newAssignedJobs[currJob.Id] + ". User that sucks: " + currJob.Client);
               if (newAssignedJobs[currJob.Id] <= 0) {
-                HiveLogger.Error(this.ToString() + " processJobProcess: Job TTL reached Zero, Job gets removed: " + currJob + " and set back to offline. User that sucks: " + currJob.Client);
+                Logger.Error("Job TTL reached Zero, Job gets removed: " + currJob + " and set back to offline. User that sucks: " + currJob.Client);
 
                 currJob.State = State.offline;
@@ -404,5 +399,5 @@
               }
             } else {
-              HiveLogger.Error(this.ToString() + " processJobProcess: Job ID wasn't with the heartbeats:  " + currJob);
+              Logger.Error("Job ID wasn't with the heartbeats:  " + currJob);
               currJob.State = State.offline;
               DaoLocator.JobDao.Update(currJob);
@@ -413,5 +408,5 @@
 
             if (newAssignedJobs.ContainsKey(currJob.Id)) {
-              HiveLogger.Info(this.ToString() + " processJobProcess: Job is sending a heart beat, removing it from the newAssignedJobList: " + currJob);
+              Logger.Info("Job is sending a heart beat, removing it from the newAssignedJobList: " + currJob);
               newAssignedJobs.Remove(currJob.Id);
             }
@@ -427,57 +422,4 @@
     /// <param name="clientId"></param>
     /// <returns></returns>
-    /*public ResponseSerializedJob SendSerializedJob(Guid clientId) {
-      ISession session = factory.GetSessionForCurrentThread();
-      ITransaction tx = null;
-
-      try {
-        IJobAdapter jobAdapter =
-          session.GetDataAdapter<JobDto, IJobAdapter>();
-
-        tx = session.BeginTransaction();
-
-        ResponseSerializedJob response = new ResponseSerializedJob();
-
-        JobDto job2Calculate = scheduler.GetNextJobForClient(clientId);
-        if (job2Calculate != null) {
-          SerializedJob computableJob =
-            jobAdapter.GetSerializedJob(job2Calculate.Id);
-
-          response.Job = computableJob;
-          response.Success = true;
-          HiveLogger.Info(this.ToString() + " SendSerializedJob: Job pulled: " + computableJob.JobInfo + " for user " + clientId);                      
-          response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_PULLED;
-          lock (newAssignedJobs) {
-            if (!newAssignedJobs.ContainsKey(job2Calculate.Id))
-              newAssignedJobs.Add(job2Calculate.Id, ApplicationConstants.JOB_TIME_TO_LIVE);
-          }
-        } else {
-          HiveLogger.Info(this.ToString() + " SendSerializedJob: No more Jobs left for " + clientId);                      
-          response.Success = false;
-          response.Job = null;
-          response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT;
-        }
-
-        tx.Commit();
-
-        return response;
-      }
-      catch (Exception ex) {
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }     */
-
-    /// <summary>
-    /// if the client was told to pull a job he calls this method
-    /// the server selects a job and sends it to the client
-    /// </summary>
-    /// <param name="clientId"></param>
-    /// <returns></returns>
     public ResponseJob SendJob(Guid clientId) {
 
@@ -487,6 +429,7 @@
       if (job2Calculate != null) {
         response.Job = job2Calculate;
+        response.Job.PluginsNeeded = DaoLocator.PluginInfoDao.GetPluginDependenciesForJob(response.Job);
         response.Success = true;
-        HiveLogger.Info(this.ToString() + " SendSerializedJob: Job pulled: " + job2Calculate + " for user " + clientId);
+        Logger.Info("Job pulled: " + job2Calculate + " for user " + clientId);
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_PULLED;
         lock (newAssignedJobs) {
@@ -494,9 +437,9 @@
             newAssignedJobs.Add(job2Calculate.Id, ApplicationConstants.JOB_TIME_TO_LIVE);
         }
-      } else {
+      } else {                  
         response.Success = false;
         response.Job = null;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT;
-        HiveLogger.Info(this.ToString() + " SendSerializedJob: No more Jobs left for " + clientId);
+        Logger.Info("No more Jobs left for " + clientId);
       }
 
@@ -510,5 +453,5 @@
       bool finished) {
 
-      HiveLogger.Info(this.ToString() + " ProcessJobResult: BEGIN Job received for Storage - main method:");
+      Logger.Info("BEGIN Job received for Storage - main method:");
 
 
@@ -547,5 +490,5 @@
         jobStream.Close();
       }
-      HiveLogger.Info(this.ToString() + " ProcessJobResult: END Job received for Storage:");
+      Logger.Info("END Job received for Storage:");
       return response;
     }
@@ -559,5 +502,5 @@
       bool finished) {
 
-      HiveLogger.Info(this.ToString() + " ProcessJobResult: BEGIN Job received for Storage - SUB method: " + jobId);
+      Logger.Info("BEGIN Job received for Storage - SUB method: " + jobId);
 
       ResponseResultReceived response = new ResponseResultReceived();
@@ -579,5 +522,5 @@
         response.JobId = jobId;
 
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: No job with Id " + jobId);
+        Logger.Error("No job with Id " + jobId);
 
         //tx.Rollback();
@@ -588,5 +531,5 @@
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_WAS_ABORTED;
 
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: Job was aborted! " + job.JobInfo);
+        Logger.Error("Job was aborted! " + job.JobInfo);
 
         //tx.Rollback();
@@ -598,5 +541,5 @@
         response.JobId = jobId;
 
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: Job is not being calculated (client = null)! " + job.JobInfo);
+        Logger.Error("Job is not being calculated (client = null)! " + job.JobInfo);
 
         //tx.Rollback();
@@ -608,5 +551,5 @@
         response.JobId = jobId;
 
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: Wrong Client for this Job! " + job.JobInfo + ", Sending Client is: " + clientId);
+        Logger.Error("Wrong Client for this Job! " + job.JobInfo + ", Sending Client is: " + clientId);
 
         //tx.Rollback();
@@ -618,9 +561,10 @@
         response.JobId = jobId;
 
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: Job already finished! " + job.JobInfo + ", Sending Client is: " + clientId);
+        Logger.Error("Job already finished! " + job.JobInfo + ", Sending Client is: " + clientId);
 
         //tx.Rollback();
         return response;
       }
+      //Todo: RequestsnapshotSent => calculating?
       if (job.JobInfo.State == State.requestSnapshotSent) {
         job.JobInfo.State = State.calculating;
@@ -632,5 +576,5 @@
         response.JobId = jobId;
 
-        HiveLogger.Error(this.ToString() + " ProcessJobResult: Wrong Job State, job is: " + job.JobInfo);
+        Logger.Error("Wrong Job State, job is: " + job.JobInfo);
 
         //tx.Rollback();
@@ -641,4 +585,5 @@
       if (finished) {
         job.JobInfo.State = State.finished;
+        job.JobInfo.DateFinished = DateTime.Now;
       }
 
@@ -652,5 +597,5 @@
       response.finished = finished;
 
-      HiveLogger.Info(this.ToString() + " ProcessJobResult: END Job received for Storage - SUB method: " + jobId);
+      Logger.Info("END Job received for Storage - SUB method: " + jobId);
       return response;
 
@@ -691,5 +636,5 @@
     public Response Logout(Guid clientId) {
 
-      HiveLogger.Info("Client logged out " + clientId);
+      Logger.Info("Client logged out " + clientId);
       
       Response response = new Response();
@@ -736,5 +681,5 @@
         response.Success = false;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_DOESNT_EXIST;
-        HiveLogger.Error(this.ToString() + " IsJobStillNeeded: Job doesn't exist (anymore)! " + jobId);
+        Logger.Error("Job doesn't exist (anymore)! " + jobId);
         return response;
       }
@@ -742,5 +687,5 @@
         response.Success = true;
         response.StatusMessage = ApplicationConstants.RESPONSE_COMMUNICATOR_JOB_ALLREADY_FINISHED;
-        HiveLogger.Error(this.ToString() + " IsJobStillNeeded: already finished! " + job);
+        Logger.Error("already finished! " + job);
         return response;
       }
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/HiveServerCorePlugin.cs	(revision 3578)
@@ -35,4 +35,5 @@
   [PluginDependency("HeuristicLab.Hive.Server.LINQDataAccess-3.2")]
   [PluginDependency("HeuristicLab.Security.Contracts-3.2")]
+  [PluginDependency("HeuristicLab.Tracing", "3.2.0")]
   public class HiveServerCorePlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/JobManager.cs	(revision 3578)
@@ -35,4 +35,5 @@
 using System.Transactions;
 using HeuristicLab.Hive.Server.LINQDataAccess;
+using IsolationLevel=System.Transactions.IsolationLevel;
 
 namespace HeuristicLab.Hive.Server.Core {
@@ -57,5 +58,5 @@
 
     public void ResetJobsDependingOnResults(JobDto job) {
-      HiveLogger.Info(this.ToString() + ": Setting job " + job.Id + " offline");
+      Logger.Info("Setting job " + job.Id + " offline");
       if (job != null) {
         DaoLocator.JobDao.SetJobOffline(job);
@@ -65,6 +66,6 @@
 
     void checkForDeadJobs() {
-      HiveLogger.Info(this.ToString() + " Searching for dead Jobs");
-      using (TransactionScope scope = new TransactionScope()) {
+      Logger.Info("Searching for dead Jobs");
+      using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required, new TransactionOptions { IsolationLevel = ApplicationConstants.ISOLATION_LEVEL_SCOPE })) {
         List<JobDto> allJobs = new List<JobDto>(DaoLocator.JobDao.FindAll());
         foreach (JobDto curJob in allJobs) {
@@ -91,10 +92,4 @@
     /// <returns></returns>
     public ResponseList<JobDto> GetAllJobs() {
-       /*ISession session = factory.GetSessionForCurrentThread();
-
-       try {
-         IJobAdapter jobAdapter =
-             session.GetDataAdapter<JobDto, IJobAdapter>();*/
-
          ResponseList<JobDto> response = new ResponseList<JobDto>();
 
@@ -104,10 +99,11 @@
 
          return response;
-       /*}
-       finally {
-         if (session != null)
-           session.EndSession();
-       } */
-    }
+    }
+
+    public ResponseList<JobDto> GetAllJobsWithFilter(State jobState, int offset, int count) {
+      ResponseList<JobDto> response = new ResponseList<JobDto>();
+      response.List = new List<JobDto>(DaoLocator.JobDao.FindWithLimitations(jobState, offset, count));
+      return response;
+    }  
 
     /// <summary>
@@ -126,10 +122,4 @@
     /// <returns></returns>
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {              
-        IJobAdapter jobAdapter =
-            session.GetDataAdapter<JobDto, IJobAdapter>();*/
-
         ResponseObject<JobDto> response = new ResponseObject<JobDto>();
 
@@ -145,9 +135,19 @@
         return response;
       }
-      /*finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }   */
+
+    public ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId) {
+      ResponseObject<JobDto> job = new ResponseObject<JobDto>();
+      job.Obj = DaoLocator.JobDao.FindById(jobId);
+      if (job.Obj != null) {
+        job.Success = true;
+        job.StatusMessage = ApplicationConstants.RESPONSE_JOB_GET_JOB_BY_ID;
+
+        job.Obj.Client = DaoLocator.ClientDao.GetClientForJob(jobId);
+      } else {
+        job.Success = false;
+        job.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
+      }      
+      return job;
+    }
 
     public ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources) {
@@ -167,10 +167,4 @@
     /// <returns></returns>
     public ResponseObject<JobDto> AddNewJob(SerializedJob job) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IJobAdapter jobAdapter =
-            session.GetDataAdapter<JobDto, IJobAdapter>();*/
-
         ResponseObject<JobDto> response = new ResponseObject<JobDto>();
 
@@ -218,10 +212,4 @@
     /// <returns></returns>
     public Response RemoveJob(Guid jobId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      try {
-        IJobAdapter jobAdapter =
-            session.GetDataAdapter<JobDto, IJobAdapter>();*/
-
         Response response = new Response();
 
@@ -238,9 +226,4 @@
         return response;
       }
-      /*finally {
-        if (session != null)
-          session.EndSession();
-      }
-    }   */
 
     public ResponseObject<JobDto> GetLastJobResultOf(Guid jobId) {
@@ -258,16 +241,4 @@
     public ResponseObject<SerializedJob>
       GetLastSerializedJobResultOf(Guid jobId, bool requested) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-
-      ITransaction tx = null;
-
-      try {
-        IJobAdapter jobAdapter =
-            session.GetDataAdapter<JobDto, IJobAdapter>();
-
-        IJobResultsAdapter jobResultsAdapter =
-          session.GetDataAdapter<JobResult, IJobResultsAdapter>();
-
-        tx = session.BeginTransaction();                          */
 
         ResponseObject<SerializedJob> response =
@@ -386,87 +357,12 @@
 
     public ResponseList<JobResult> GetAllJobResults(Guid jobId) {
-     /* ISession session = factory.GetSessionForCurrentThread();
-      ResponseList<JobResult> response = new ResponseList<JobResult>();
-
-      try {
-        IJobResultsAdapter jobResultAdapter =
-            session.GetDataAdapter<JobResult, IJobResultsAdapter>();
-        IJobAdapter jobAdapter = session.GetDataAdapter<JobDto, IJobAdapter>();
-
-        JobDto job = jobAdapter.GetById(jobId);
-        if (job == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST;
-          return response;
-        }
-        response.List = new List<JobResult>(jobResultAdapter.GetResultsOf(job.Id));
-        response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_JOB_RESULT_SENT;
-
-        return response;
-      }
-      finally {
-        if(session != null)
-          session.EndSession();
-      }  */
       return new ResponseList<JobResult>();
     }
 
     public ResponseList<ProjectDto> GetAllProjects() {
-      /*ISession session = factory.GetSessionForCurrentThread();
-      ResponseList<ProjectDto> response = new ResponseList<ProjectDto>();
-
-      try {
-        IProjectAdapter projectAdapter =
-          session.GetDataAdapter<ProjectDto, IProjectAdapter>();
-
-        List<ProjectDto> allProjects = new List<ProjectDto>(projectAdapter.GetAll());
-        response.List = allProjects;
-        response.Success = true;
-        return response;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      } */
       return null;
     }
 
     private Response createUpdateProject(ProjectDto project) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-      Response response = new Response();
-      ITransaction tx = null;
-
-      try {
-        IProjectAdapter projectAdapter =
-          session.GetDataAdapter<ProjectDto, IProjectAdapter>();
-
-        if (project.Name == null || project.Name == "") {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_PROJECT_NAME_EMPTY;
-          return response;
-        }
-        tx = session.BeginTransaction();
-        projectAdapter.Update(project);
-
-        tx.Commit();
-        response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_PROJECT_ADDED;
-      } catch (ConstraintException ce) {
-        if (tx != null)
-          tx.Rollback();
-        response.Success = false;
-        response.StatusMessage = ce.Message;
-      }
-      catch (Exception ex) {
-        if (tx != null)
-          tx.Rollback();
-        throw ex;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }
-      return response;    */
       return null;
     }
@@ -481,57 +377,10 @@
 
     public Response DeleteProject(Guid projectId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-      Response response = new Response();
-      ITransaction tx = null;
-
-      try {
-        IProjectAdapter projectAdapter =
-          session.GetDataAdapter<ProjectDto, IProjectAdapter>();
-
-        ProjectDto project = projectAdapter.GetById(projectId);
-        if (project == null) {
-          response.Success = false;
-          response.StatusMessage = ApplicationConstants.RESPONSE_JOB_PROJECT_DOESNT_EXIST;
-          return response;
-        }
-        projectAdapter.Delete(project);
-        tx.Commit();
-        response.Success = true;
-        response.StatusMessage = ApplicationConstants.RESPONSE_JOB_PROJECT_DELETED;
-      }
-      catch (Exception e) {
-        if (tx != null)
-          tx.Rollback();
-        response.Success = false;
-        response.StatusMessage = e.Message;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      }     
-      return response; */
       return null;
     }
 
     public ResponseList<JobDto> GetJobsByProject(Guid projectId) {
-      /*ISession session = factory.GetSessionForCurrentThread();
-      ResponseList<JobDto> response = new ResponseList<JobDto>();
-
-      try {
-        IJobAdapter jobAdapter =
-          session.GetDataAdapter<JobDto, IJobAdapter>();
-        List<JobDto> jobsByProject = new List<JobDto>(jobAdapter.GetJobsByProject(projectId));
-        response.List = jobsByProject;
-        response.Success = true;
-      }
-      finally {
-        if (session != null)
-          session.EndSession();
-      } 
-       
-      return response;*/
       return null;      
     }
-
     #endregion
   }
Index: /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.Core/3.2/ServerConsoleFacade.cs	(revision 3578)
@@ -97,7 +97,17 @@
     }
 
+    public ResponseList<JobDto> GetAllJobsWithFilter(State jobState, int offset, int count) {
+      secMan.Authorize("AccessJobs", sessionID, Guid.Empty);
+      return jobManager.GetAllJobsWithFilter(jobState, offset, count);
+    }
+
     public ResponseObject<JobDto> GetJobById(Guid jobId) {
       secMan.Authorize("AccessJobs", sessionID, jobId);
       return jobManager.GetJobById(jobId);
+    }
+
+    public ResponseObject<JobDto> GetJobByIdWithDetails(Guid jobId) {
+      secMan.Authorize("AccessJobs", sessionID, jobId);
+      return jobManager.GetJobByIdWithDetails(jobId);
     }
 
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IJobDao.cs	(revision 3578)
@@ -21,4 +21,6 @@
     IEnumerable<JobDto> FindFittingJobsForClient(State state, int freeCores, int freeMemory, Guid clientGuid);
     Stream GetSerializedJobStream(Guid jobId);
+
+    IEnumerable<JobDto> FindWithLimitations(State jobState, int offset, int count);
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoDao.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.DataAccess/3.2/IPluginInfoDao.cs	(revision 3578)
@@ -7,4 +7,5 @@
   public interface IPluginInfoDao: IGenericDao<HivePluginInfoDto> {    
     void InsertPluginDependenciesForJob(JobDto jobDto);
+    List<HivePluginInfoDto> GetPluginDependenciesForJob(JobDto jobDto);
   }
 }
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/BaseDao.cs	(revision 3578)
@@ -3,4 +3,6 @@
 using System.Linq;
 using System.Text;
+using System.Data.Linq;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Server.LINQDataAccess {
@@ -12,4 +14,15 @@
     }
 
+    protected void CommitChanges() {
+      try {
+        Context.SubmitChanges(ConflictMode.ContinueOnConflict);
+      } catch (ChangeConflictException e) {
+        Logger.Warn("Concurrency Exception! " + e.Message);
+        foreach (ObjectChangeConflict conflict in Context.ChangeConflicts) {          
+          conflict.Resolve(RefreshMode.KeepChanges);
+        }
+      }
+    }
+
     public abstract TDatabaseEntity DtoToEntity(TBusiness source, TDatabaseEntity target);
     public abstract TBusiness EntityToDto(TDatabaseEntity source, TBusiness target);
Index: /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientConfigDao.cs
===================================================================
--- /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientConfigDao.cs	(revision 3577)
+++ /trunk/sources/HeuristicLab.Hive.Server.LINQDataAccess/3.2/ClientConfigDao.cs	(revision 3578)
@@ -26,5 +26,5 @@
       ClientConfig c = DtoToEntity(bObj, null);
       Context.ClientConfigs.InsertOnSubmit(c);
-      Context.SubmitChanges();
+      CommitChanges();
       bObj.Id = c.ClientConfigId;
       return bObj;  
@@ -33,5 +33,5 @@
     public void Delete(ClientConfigDto bObj) {
       Context.ClientConfigs.DeleteOnSubmit(Context.ClientConfigs.SingleOrDefault(c => c.ClientConfigId.Equals(bObj.Id)));
-      Context.SubmitChanges();
+      CommitChanges();
     }
 
@@ -39,5 +39,5 @@
       ClientConfig cc = Context.ClientConfigs.SingleOrDefault(c => c.ClientConfigId.Equals(bObj.Id));
       DtoToEntity(bObj, cc);
-      Context.SubmitChanges();
+      CommitChanges();
     }
 
